// This file contains the addresses to various functions and data structures
// within StarCraft.

#pragma once
#include "types.h"

/*
 *  These addresses are from the BWAPI/BWAI team, Poiuy_qwert,
 *  the EUDDB, BWHacks, and myself.  Thank you everyone :D .
 */

namespace v1161 {
//Addresses for function injects and hooks
const u32 GameStart             = 0x004C9A51;
const u32 GameStartBack         = GameStart + 5;
const u32 GameStartTarget       = 0x00417C20;
const u32 GameEnd               = 0x004EE983;
const u32 GameEndBack           = GameEnd + 5;
const u32 GameEndTarget         = 0x00416D90;
const u32 NextLogicFrame        = 0x004D974E;
const u32 NextLogicFrameBack    = NextLogicFrame + 5;
const u32 NextLogicFrameTarget  = 0x00488780;

const u32 StimPacksHpCostToEdx        = 0x004234D9;
const u32 StimPacksHpCostCmp1         = 0x004554A3; //NOP 2 bytes
const u32 StimPacksHpCostToEax1       = 0x004554D2;
const u32 StimPacksHpCostCmp2         = 0x004C2F68; //NOP 2 bytes
const u32 StimPacksHpCostToEax2       = 0x004C2FD4;

const u32 RegenerateUnitHp            = 0x004EC364;
const u32 RegenerateUnitHpBack        = 0x004EC38E;

const u32 EnergyRegenAmount           = 0x004EB55F; //NOP 2 bytes

const u32 CanConsumeUnit              = 0x00491F51;

const u32 ConsumeEnergyGain           = 0x004F47F9;
const u32 ConsumeEnergyGainBack       = 0x004F4808;

const u32 DoPlagueDamage              = 0x00493088;
const u32 DoPlagueDamageBack          = 0x004930C2;

const u32 MaxRechargeShields_EcxEax1  = 0x004934B9; //ApplyRechargeShields(); NOP 3 bytes
const u32 MaxRechargeShields_EcxEax2  = 0x004934F7; //ApplyRechargeShields(); NOP 3 bytes
const u32 MaxRechargeShields_EsiEcx   = 0x0049356B; //unitCanRechargeShields(); NOP 3 bytes
const u32 MaxRechargeShields_EdiEcx   = 0x00493EDB; //orders_RechargeShields1(); NOP 3 bytes

const u32 RegenerateShields           = 0x004EC2C3;  //updateUnitTimers()
const u32 RegenerateShieldsChanged    = 0x004EC2F0;
const u32 RegenerateShieldsUnchanged  = 0x004EC2FE;

const u32 ModifyUnitSpeed             = 0x0047B5F0;
const u32 ModifyUnitAcceleration      = 0x0047B8A0;
const u32 ModifyUnitTurnSpeed         = 0x0047B850;
const u32 ModifyWeaponCooldown        = 0x00475DC0;

const u32 OrderNewUnitToRally         = 0x00466F62;
const u32 OrderNewUnitToRallyBack     = 0x00466FA3;

//Adresses for customizing maximum sight range
const u32 SightStructArrayRef      = 0x00480709; //The pointer to the SightStruct array must be injected here
const u32 InitializeSightValues    = 0x0042AD60; //The internal function responsible for setting up the array
const u32 MapTileWidth        = 0x0057F1D4; //Some kind of WORD variable that initializeSightValues() needs

//Addresses for data in arr\*.dat files
const u32 UnitsDat    = 0x00513C30;  // 1.15.3, 1.16, 1.16.1
const u32 WeaponsDat    = 0x00513868;
const u32 FlingyDat    = 0x00515A38;
const u32 UpgradesDat    = 0x005136E0;
const u32 TechdataDat    = 0x005137D8;

//Addresses of commonly used arrays and data structures
const u32 Resources     = 0x0057F0F0;
const u32 PlayerTable   = 0x0057EEE0;
const u32 UnitDeaths    = 0x0058A364;  //++Taken from modified GPTP of xAngelSpiritx
const u32 UnitTable     = 0x0059CCA8;
const u32 LocationTable = 0x0058DC60;  //++Taken from modified GPTP of xAngelSpiritx
const u32 ActionTable   = 0x00512800;  //++Taken from modified GPTP of xAngelSpiritx
const u32 BulletTable   = 0x0064B2E8;
const u32 FirstVisibleUnit  = 0x00628430; //Taken from BWAPI's Offsets.h
const u32 FirstHiddenUnit   = 0x006283EC; //Taken from BWAPI's Offsets.h
const u32 FirstScannerSweep = 0x006283F4; //Taken from BWAPI's Offsets.h
const u32 FirstBullet       = 0x0064DEC4; //Taken from BWAPI's Offsets.h

//Addresses of useful SCBW internal constants (defined in scbwdata.h)
const u32 Is_Game_Paused      = 0x006509C4;
const u32 Hp_Regen_Amount     = 0x004EC386;
const u32 Energy_Regen_Amount = 0x004EB55E;
const u32 Shield_Regen_Amount = 0x004EC2E5;
const u32 Plague_Timer        = 0x004F45A6;
const u32 Consume_Energy_Gain = 0x004F4804;

//Addresses of useful SCBW internal functions (defined in api.h)
const u32 PrintText           = 0x0048CD30;
const u32 DoWeaponDamage      = 0x00479930;
const u32 RemoveOverlays      = 0x004E5CF0;
const u32 CreateOverlay       = 0x00498EA0;
const u32 SetUnitHp           = 0x00467340;
const u32 DamageUnitHp        = 0x004797B0;
const u32 FireUnitWeapon      = 0x00479C90;
const u32 PlayIscriptAnim     = 0x004D8470; //AKA playImageIscript()
const u32 CreateUnitAtPos     = 0x004CD360; //AKA createUnitXY()
const u32 OrderToUnit         = 0x004752B0; //AKA AssignOrderWithTarget(); Primarily for use with orderNewUnitToRally(), but may have other uses.
const u32 OrderToPos          = 0x00475260; //AKA orderTarget(); Primarily for use with orderNewUnitToRally(), but may have other uses.
const u32 CanBeEnteredBy      = 0x004E6E00; //AKA CanEnterTransport()
const u32 HasPathToPos        = 0x0049CB60; //AKA unitHasPathToDest()
const u32 HasPathToTarget     = 0x0049CBB0; //AKA unitHasPathToUnit()
const u32 IsTargetWithinRange = 0x00430F10; //AKA isTargetWithinMinRange()
const u32 GetDistanceFast     = 0x0040C360;
}

namespace v1151 {
const u32 GameStart        = 0x004C9691;
const u32 GameStartBack      = GameStart + 5;
const u32 GameStartTarget      = 0x00417C10;
const u32 GameEnd          = 0x004EE5C3;
const u32 GameEndBack        = GameEnd + 5;
const u32 GameEndTarget      = 0x00416D80;
const u32 NextLogicFrame      = 0x004D936E;
const u32 NextLogicFrameBack    = NextLogicFrame + 5;
const u32 NextLogicFrameTarget  = 0x00488420;

//Addresses for data in arr\*.dat files
const u32 UnitsDat    = 0x00513C30;  // 1.15.3, 1.16, 1.16.1
const u32 WeaponsDat    = 0x00513868;
const u32 FlingyDat    = 0x00515A38;
const u32 UpgradesDat    = 0x005136E0;
const u32 TechdataDat    = 0x005137D8;

const u32 Resources = 0x0057F0D8;
const u32 PlayerTable = 0x0057EEC0;
const u32 UnitDeaths = 0x0058A34C;
const u32 UnitTable = 0x0059CC90;
const u32 LocationTable = 0x0058DC48;
const u32 ActionTable = 0x00512800;

//Addresses of useful SCBW internal constants (defined in scbwdata.h)
const u32 Game_Is_Paused    = 0x006509AC; //Haven't checked

const u32 NameSpoofer = 0x19044EA8;
const u32 HostHack = 0x00596870;
const u32 HostName = 0x00596814; //for auto-spoof to host name
const u32 CurrentPlayerSlot = 0x00512684;
const u32 PrintText = 0x48CE60;
const u32 PrintTextAnywhere = 0x4202A0;
const u32 FontSize = 0x41FB20;

enum FontSize
{
  Small = 0x6CE0DC,
  Normal = 0x6CE0E0,
  Large = 0x6CE0E4,
  Huge = 0x6CE0E8
};

const u32 GameText = 0x4F2EC0; // Send Messages 1.15.1
const u32 HostFunc = 0x4C46D0; // host function for banning, open, close, computer, 1.15.1
const u32 HostHack2 = 0x4512D8; // lets you be host even if ur not 1.15.1
const u32 LbyJMPb = 0x4B9583; // offset to jump back to lobby handle text 1.15.1
const u32 GameJMPb = 0x4F2FFC; // Offset to jump back to from game text handle. 1.15.1
const u32 CLobbySendText = 0x4B8BB0; // Client: sends text to lobby 1.15.1

const u32 HealthBarHack = 0x004E5E62;
  /*
   * Original Poster:
   * "NOPing twice makes Starcraft unit's Health bars
   * display without having to click on them.
   * Like Warcraft 3's Alt button."
   *
   * Me:
   * "I've found that NOPing this address in OllyDbg
   * causes only the first ~12 units clicked to
   * ALWAYS display their health bar.  I'm not sure
   * if the OP meant to NOP the whole function (which
   * is about 6 lines) or to just NOP the address.
   * Either way, test this one with caution."
   *
   * BTW, NOPing means filling the address with WORD 0x90 (?).
   *
   */
}
