//This file contains declarations of GPTP's hook functions.

#pragma once
#include "SCBW/unit.h"


/******** Core plugin hooks ********/
bool gameOn();
void onGameStart();

bool gameEnd();
void onGameEnd();

bool nextFrame();
void nextFrameHook();

/******** Hooks for customizing Stim Packs HP cost ********/
u32 getStimPacksHpCost(const UNIT*);
void stimPacksHpCostToEdx();
void stimPacksHpCostCmp();
void stimPacksHpCostToEax();

/******** Hooks for controlling unit HP regeneration ********/
void regenerateUnitHp(UNIT*);
void regenerateUnitHpHook();

/******** Hook for modifying unit energy regeneration ********/
u16 energyRegenAmount(const UNIT*);
void energyRegenAmountHook();

/******** Hook for controlling which units can be Consumed ********/
bool canConsumeUnit(const UNIT* unit, u8 consumingPlayer);
void canConsumeUnitHook();

/******** Hook for modifying how much energy is gained by Consume ********/
u32 consumeEnergyGain(const UNIT* consumeTarget);
void consumeEnergyGainHook();

/******** Hook for controlling Plague effects ********/
void doPlagueDamage(UNIT*);
void doPlagueDamageHook();

/******** Hook for controlling unit shield regeneration ********/
bool regenerateShields(UNIT* unit);
void regenerateShieldsHook();

/******** Hooks for modifying how much shields can be recharged ********/
u32 maxRechargeShields(const UNIT*);
void maxRechargeShields_EcxEax();
void maxRechargeShields_EsiEcx();
void maxRechargeShields_EdiEcx();

/******** Hooks for modifying unit speed, acceleration, and turn speed ********/
u32 modifyUnitSpeed(const UNIT* unit, u32 baseSpeed);
void modifyUnitSpeedHook();

u32 modifyUnitAcceleration(const UNIT* unit);
void modifyUnitAccelerationHook();

u32 modifyUnitTurnSpeed(const UNIT* unit);
void modifyUnitTurnSpeedHook();

/******** Hook for modifying weapon cooldown ********/

u32 modifyWeaponCooldown(const UNIT* unit, u8 weaponId);
void modifyWeaponCooldownHook();

/******** Hooks for controlling rally orders of new units ********/

void orderNewUnitToRally(UNIT* unit, UNIT* factory);
void orderNewUnitToRallyHook();
