#pragma once
#include "definitions.h"
#include "SCBW/offsets.h"
#include "tools.h"
#include "hooks.h"

/// This function is called when the plugin is loaded into StarCraft.
/// You can enable/disable each group of hooks by commenting them.
/// You can also add custom modifications to StarCraft.exe by using:
///    memoryPatch(address_to_patch, value_to_patch_with);

void Initialize() {
  /******** Hooks for general plugin functions ********/
//  jmpPatch(onGameStart,          VERSION::GameStart);    // From BWAPI by Kovarex
//  jmpPatch(onGameEnd,            VERSION::GameEnd);      // From BWAPI by Kovarex
//  jmpPatch(nextFrameHook,        VERSION::NextLogicFrame);  // From BWAPI by Kovarex

  /******** Hooks for modifying the HP cost of Stim Packs ********/
//  callPatch(stimPacksHpCostToEdx,   VERSION::StimPacksHpCostToEdx);
//  callPatch(stimPacksHpCostCmp,     VERSION::StimPacksHpCostCmp1, 2);
//  callPatch(stimPacksHpCostCmp,     VERSION::StimPacksHpCostCmp2, 2);
//  callPatch(stimPacksHpCostToEax,   VERSION::StimPacksHpCostToEax1);
//  callPatch(stimPacksHpCostToEax,   VERSION::StimPacksHpCostToEax2);

  /******** Hook for controlling unit HP regeneration ********/
//  jmpPatch(regenerateUnitHpHook,    VERSION::RegenerateUnitHp);

  /******** Hook for modifying unit energy regeneration ********/
//  callPatch(energyRegenAmountHook,  VERSION::EnergyRegenAmount, 2);

  /******** Hook for controlling which units can be consumed ********/
//  jmpPatch(canConsumeUnitHook,    VERSION::CanConsumeUnit);

  /******** Hook for modifying how much energy is gained by Consume ********/
//  jmpPatch(consumeEnergyGainHook,    VERSION::ConsumeEnergyGain);

  /******** Hook for controlling Plague effects ********/
//  jmpPatch(doPlagueDamageHook,    VERSION::DoPlagueDamage);

  /******** Hooks for modifying how much shields can be recharged ********/
//  callPatch(maxRechargeShields_EcxEax,  VERSION::MaxRechargeShields_EcxEax1,  3);
//  callPatch(maxRechargeShields_EcxEax,  VERSION::MaxRechargeShields_EcxEax2,  3);
//  callPatch(maxRechargeShields_EsiEcx,  VERSION::MaxRechargeShields_EsiEcx,   3);
//  callPatch(maxRechargeShields_EdiEcx,  VERSION::MaxRechargeShields_EdiEcx,   3);

  /******** Hook for controlling unit shield regeneration ********/
//  jmpPatch(regenerateShieldsHook,    VERSION::RegenerateShields);

  /******** Hooks for modifying unit speed, acceleration, and turn speed ********/
//  jmpPatch(modifyUnitSpeedHook,    VERSION::ModifyUnitSpeed);
//  jmpPatch(modifyUnitAccelerationHook,VERSION::ModifyUnitAcceleration);
//  jmpPatch(modifyUnitTurnSpeedHook,  VERSION::ModifyUnitTurnSpeed);

  /******** Hook for modifying weapon cooldown ********/
//  jmpPatch(modifyWeaponCooldownHook,  VERSION::ModifyWeaponCooldown);

  /******** Hook for controlling rally orders of new units ********/
  jmpPatch(orderNewUnitToRallyHook, VERSION::OrderNewUnitToRally);
}
